//+------------------------------------------------------------------+
//|                                                       wpr SR.mq4 |
//| coded after the idae of bulliz                                   |
//| so the credits go to him                                         |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red

//
//
//
//
//

extern int    WprPeriod         = 20;
extern double LevelUp           = -40; 
extern double LevelDown         = -60; 
extern bool   ShowTillChange    = false;
extern int    BarForSRHighsLows = 0;
extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = false;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = true;
extern bool   alertsEmail       = false;



//
//
//
//
//

double wpr[];
double resistance[];
double support[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                 
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits (5);
   IndicatorBuffers(4);
   SetIndexBuffer(0,resistance);
   SetIndexBuffer(1,support);
   SetIndexBuffer(2,wpr); 
   SetIndexBuffer(3,trend);
   
      SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   
   SetIndexLabel(0,"Wpr-b0-Buy-Blue 1");
   SetIndexLabel(1,"Wpr-b1-Sell-Red -1");
   SetIndexLabel(2,"Wpr-b2-(Pd)("+WprPeriod+")");
   SetIndexLabel(3,"Wpr-b3-SRtrd");


   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                 
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      wpr[i]        = iWPR(NULL,0,WprPeriod,i);
      resistance[i] = resistance[i+1];
      support[i]    = support[i+1];
      trend[i]      = trend[i+1];
   
         //
         //
         //
         //
         //
         
         if (wpr[i]>LevelUp)   trend[i] =  1;
         if (wpr[i]<LevelDown) trend[i] = -1;
         
         //
         //
         //
         //
         //
         
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1)
               {
                  resistance[i] = High[i+BarForSRHighsLows];
                  if (!ShowTillChange)
                     support[i] = EMPTY_VALUE;
               }                     
            else
               {
                  support[i] = Low[i+BarForSRHighsLows];
                  if (!ShowTillChange)
                     resistance[i] = EMPTY_VALUE;
               }                     
         }
   }
   manageAlerts();
   return(0);
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol(),"  ",TimeToStr(TimeLocal(),TIME_SECONDS)," Wpr-S&R trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Wpr-S&R"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                

